unit Main;

interface

uses
  Windows, Messages, SysUtils, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Gauges, Classes;

type
  TMainForm = class(TForm)
    TimClick: TTimer;
    Panel2: TPanel;
    ImgHiscore: TImage;
    LblHiscore: TLabel;
    ImgClick: TImage;
    GgTime: TGauge;
    PnlMonkey: TPanel;
    Panel1: TPanel;
    ImgClickHere: TImage;
    ImgNowScore: TImage;
    PbNowScore: TPaintBox;
    procedure PnlMonkeyClick(Sender: TObject);
    procedure PbNowScorePaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimClickTimer(Sender: TObject);
    procedure PnlMonkeyMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure ImgHiscoreClick(Sender: TObject);
  private

  public

  end;

var
  MainForm: TMainForm;

implementation

uses
    Score;

{$R *.dfm}

var
    Counter: integer = 0;
    Tick: integer = 0;
    Timer: integer = 0;

//  ---------------------------------------------------------------------------
//  b
const
    MAX_SECONDS = 1000 * 10;

//  ---------------------------------------------------------------------------
//  tH[NGCg
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  h~
    PbNowScore.ControlStyle := PbNowScore.ControlStyle + [csOpaque];
    //  ł点悤Q[Wőlݒ
    GgTime.MaxValue := MAX_SECONDS;
    //  NbNtE
    PnlMonkey.OnMouseUp := nil;
end;

//  ---------------------------------------------------------------------------
//  Cx
procedure TMainForm.FormShow(Sender: TObject);
var
    HiScore: integer;
begin
    Application.Minimize();
    Application.Restore();

    HiScore := ScoreForm.GetHiScore();
    LblHiscore.Caption := Format('%6.6d', [HiScore]);
end;

//  ---------------------------------------------------------------------------
//  ݂̃NbN`
procedure TMainForm.PbNowScorePaint(Sender: TObject);
begin
    PbNowScore.Canvas.TextRect(PbNowScore.ClientRect, 25, 0, Format('%6.6d', [Counter]));
end;

//  ---------------------------------------------------------------------------
//
procedure TMainForm.TimClickTimer(Sender: TObject);
var
    dTick: integer;
    HiScore: integer;
begin
    //  bc炷
    dTick := GetTickCount() - Cardinal(Tick);
    Dec(Timer, dTick);
    //  ߂Čݎ擾
    Tick := GetTickCount();
    //  }CiXɂȂĂI
    if (Timer <= 0) then Timer := 0;
    //  Q[W\
    GgTime.Progress := Timer;
    //  Q[WFȂɕύX
    if (GgTime.PercentDone < 10) then GgTime.ForeColor := clRed;
    //  }CiXɂȂĂI
    if (Timer = 0) then
    begin
        //  NbNtI
        PnlMonkey.OnMouseUp := nil;
        //  ^C}[E
        TimClick.Enabled := false;
        //  Q[WFɖ߂
        GgTime.ForeColor := clBlue;
        //  Ȃ̕\
        PnlMonkey.Caption := 'CLICK OVER ...';
        //  XRA\ƃnCXRAXV
        ScoreForm.DispScore(Counter);
        HiScore := ScoreForm.GetHiScore();
        LblHiscore.Caption := Format('%6.6d', [HiScore]);
        //  \Ȃɂ
        PnlMonkey.Caption := 'BE MONKEY';
        Counter := 0;
        PbNowScore.Repaint();
        //  ̃og󂯕tJn
        PnlMonkey.OnClick := PnlMonkeyClick;
        //  nCXRA\t
        ImgHiscore.OnClick := ImgHiscoreClick;
    end;
end;

//  ---------------------------------------------------------------------------
//  XRA\
procedure TMainForm.ImgHiscoreClick(Sender: TObject);
begin
    ScoreForm.DispScore();
end;

//  ---------------------------------------------------------------------------
//  NbNJn
procedure TMainForm.PnlMonkeyClick(Sender: TObject);
begin
    //  JnCxgE
    PnlMonkey.OnClick := nil;
    //  nCXRA\E
    ImgHiscore.OnClick := nil;
    //  Ȃ̕\
    PnlMonkey.Caption := 'DO CLICK AS MONKEY !!!';
    //  JE^[Zbg
    Counter := 0;
    //  ~bgbݒ
    Timer := MAX_SECONDS;
    //  Q[Wʒuݒ
    GgTime.Progress := GgTime.MaxValue;
    //  ݎ擾
    Tick := GetTickCount();
    //  ^C}[Jn
    TimClick.Enabled := true;
    //  NbNtJn
    PnlMonkey.OnMouseUp := PnlMonkeyMouseUp;
end;

//  ---------------------------------------------------------------------------
//  NbN
procedure TMainForm.PnlMonkeyMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  JE^[𑝂₵
    Inc(Counter);
    //  `
    PbNowScore.Repaint();
end;

end.

